 /*
  * Khoros: $Id: lvstats.h,v 1.1 1991/05/10 04:15:50 khoros Exp $
  */

 /*
  * $Log: lvstats.h,v $
 * Revision 1.1  1991/05/10  04:15:50  khoros
 * Initial revision
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1990, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"	 /* Copyright 1990 by UNM */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>                                                       <<<<
   >>>>	    file name: lvstats.h                              <<<<
   >>>>                                                       <<<<
   >>>>      contains: Definition of the statistical inform-  <<<<
   >>>>                ation structure used by lvstats.       <<<<
   >>>>                                                       <<<<
   >>>>      written by: Scott R. Wilson		      <<<<
   >>>>                                                       <<<<
   >>>>      date: 6/3/88                                     <<<<
   >>>>                                                       <<<<
   >>>>      modifications:				      <<<<
   >>>>                                                       <<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _lvstats_h_
#define _lvstats_h_

struct lvstat
{
    float  mean;   /* Mean value */
    float  rms;    /* RMS value */
    float  sdev;   /* Standard deviation */
    float  var;    /* Variance */
    float  fmin;   /* Minimum over whole image */
    float  fmax;   /* Maximum over whole image */
    float  integ;  /* Integral under image */
    float  pinteg; /* Positive part of integral under image */
    float  ninteg; /* Negative part of integral under image */
    float  entropy; /* entropy of entire image */
    float  contrast; /* contrast of entire image */
    float  skewness; /* skewness of entire image */
    float  kurtosis; /* kurtosis of entire image */
float xslope;
float yslope;
float piston;
    int    cpts;   /* Number of contributing points */
    int    pos;    /* Number of positive points points */
    int    neg;    /* Number of negative points points */
    int    minx;   /* X coordinate of minimum value */
    int    minp;   /* absolute vector position of minimum value */
    int    miny;   /* Y coordinate of minimum value */
    int    maxx;   /* X coordinate of maximum value */
    int    maxy;   /* Y coordinate of maximum value */
    int    maxp;   /* absolute vector position of maximum value */
};

#endif
/* Don't add after the endif */
